/****************************************Copyright (c)*************************
**                               Ȩ (C), 2015-2020, ͿѻƼ
**
**                                 http://www.tuya.com
**
**--------------ļϢ-------------------------------------------------------
**      : User_Uart.c
**        : uartû
**ʹ  ˵  : 
**
**
**--------------ǰ汾޶---------------------------------------------------

**   : v2.0
** ա: 2016329
** 衡: 1:Żṹ
**
**-----------------------------------------------------------------------------
******************************************************************************/
#define HAL_USER_UART_GLOBAL
#include "include.h"

#include "wifi.h"


extern uint8_t Timer4_Value;
volatile uint16_t uart_input_count;
volatile uint8_t uart_input_finish;
volatile uint8_t pm25_buffer[16];
/*****************************************************************************
 : USART1_Init
 : USART1ʼ
 : BaudRate:
ز : ʼɹ/ʧ
ʹ˵ : 
*****************************************************************************/
uint8_t USART1_Init(uint32_t BaudRate)
{
  USART_InitTypeDef USART_InitStructure; 
  GPIO_InitTypeDef GPIO_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  
  if(BaudRate > 115200) 
  {                                            //̫ߣ󷵻
    return(ERROR);
  }
  
  // Enable GPIOA clocks 
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOA, (FunctionalState)ENABLE);
  // Enable USART1 clocks 
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_USART1, (FunctionalState)ENABLE);
  
  /*
  *  USART1_TX -> PA9 , USART1_RX -> PA10
  */				
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;	         
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  
  GPIO_Init(GPIOA, &GPIO_InitStructure);		   
  
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;	        
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;  
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
  GPIO_Init(GPIOA, &GPIO_InitStructure);
  //
  USART_InitStructure.USART_BaudRate = BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(USART1, &USART_InitStructure); 
  //
  USART_ITConfig(USART1, USART_IT_RXNE, (FunctionalState)ENABLE);
  USART_ITConfig(USART1, USART_IT_TXE, (FunctionalState)DISABLE);
  //
  USART_ClearFlag(USART1,USART_FLAG_TC);
  
  //Enable the USART1 Interrupt
  NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;                             //ָжԴ
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;                     //ռȼ
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 1;                            //ָӦȼ
  NVIC_InitStructure.NVIC_IRQChannelCmd = (FunctionalState)ENABLE;                               //ж
  NVIC_Init(&NVIC_InitStructure);                                               //д
  //
  uart_input_finish = 0;
  uart_input_count = 0;
  
  USART_Cmd(USART1, (FunctionalState)ENABLE);
  
  return(SUCCESS);
}
/*****************************************************************************
 : USART3_Init
 : USART3ʼ
 : BaudRate:
ز : ʼɹ/ʧ
ʹ˵ : 
*****************************************************************************/
uint8_t USART3_Init(uint32_t BaudRate)
{
  USART_InitTypeDef USART_InitStructure; 
  GPIO_InitTypeDef GPIO_InitStructure;
  NVIC_InitTypeDef NVIC_InitStructure;
  
  if(BaudRate > 115200) 
  {                                            //̫ߣ󷵻
    return(ERROR);
  }
  
  // Enable GPIOA clocks 
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, (FunctionalState)ENABLE);
  // Enable USART1 clocks 
  RCC_APB1PeriphClockCmd(RCC_APB1Periph_USART3, (FunctionalState)ENABLE);
  
  /*
  *  USART3_TX -> PB10 , USART13_RX -> PB11
  */				
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;	         
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP; 
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;  
  GPIO_Init(GPIOB, &GPIO_InitStructure);		   
  
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;	        
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;  
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz; 
  GPIO_Init(GPIOB, &GPIO_InitStructure);
  //
  USART_InitStructure.USART_BaudRate = BaudRate;
  USART_InitStructure.USART_WordLength = USART_WordLength_8b;
  USART_InitStructure.USART_StopBits = USART_StopBits_1;
  USART_InitStructure.USART_Parity = USART_Parity_No;
  USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
  USART_InitStructure.USART_Mode = USART_Mode_Rx | USART_Mode_Tx;
  USART_Init(USART3, &USART_InitStructure); 
  //
  USART_ITConfig(USART3, USART_IT_RXNE, (FunctionalState)ENABLE);
  USART_ITConfig(USART3, USART_IT_TXE, (FunctionalState)DISABLE);
  //
  USART_ClearFlag(USART3,USART_FLAG_TC);
  
  //Enable the USART3 Interrupt
  NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;                             //ָжԴ
  NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 0;                     //ռȼ
  NVIC_InitStructure.NVIC_IRQChannelSubPriority = 0;                            //ָӦȼ
  NVIC_InitStructure.NVIC_IRQChannelCmd = (FunctionalState)ENABLE;                               //ж
  NVIC_Init(&NVIC_InitStructure);                                               //д
  
  USART_Cmd(USART3, (FunctionalState)ENABLE);
  
  return(SUCCESS);
}
/*****************************************************************************
 : USART1_IRQHandler
 : USART1жϺ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
void USART1_IRQHandler(void)
{
  uint8_t ch;
  
  //ж
  if(USART_GetITStatus(USART1, USART_IT_RXNE) != RESET)
  {
    ch = USART_ReceiveData(USART1);
    
    TIM_Cmd(TIM4, (FunctionalState)DISABLE);                                                     //ʹTIMx
    Timer4_Value = 0;
    pm25_buffer[uart_input_count] = ch;
    uart_input_count ++;
    
    TIM_Cmd(TIM4, (FunctionalState)ENABLE); 
  }
}
/*****************************************************************************
 : USART1_IRQHandler
 : USART1жϺ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
void USART3_IRQHandler(void)
{
  uint8_t ch;
  
  //ж
  if(USART_GetITStatus(USART3, USART_IT_RXNE) != RESET)
  {
    ch = USART_ReceiveData(USART3);

    //յֽݴuart_receive_input
    uart_receive_input(ch);                                                      //ʹTIMx
  }
}
/*****************************************************************************
 : Uart_PutChar
 : ڷͺ
 : ch:
ز : 
ʹ˵ : 
*****************************************************************************/
void Uart_PutChar(uint8_t ch)
{
  //
  USART_SendData(USART3,ch);
  //
  while(USART_GetFlagStatus(USART3, USART_FLAG_TC) == RESET);
}
