/****************************************Copyright (c)*************************
**                               Ȩ (C), 2015-2020, ͿѻƼ
**
**                                 http://www.tuya.com
**
**--------------ļϢ-------------------------------------------------------
**      : Hal_Temp_hum.c
**        : ʪȶȡ
**ʹ  ˵  : 
**
**
**--------------ǰ汾޶---------------------------------------------------

**   : v2.0
** ա: 2016329
** 衡: 1:Żṹ
**
**-----------------------------------------------------------------------------
******************************************************************************/
#define HAL_TEMPER_HUM_GLOBAL
#include "include.h"

#include "wifi.h"


/*****************************************************************************
 : DHT11_Rst
 : DHT11λ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static void DHT11_Rst(void)	   
{                 
  DHT11_IO_OUT(); 								
  DHT11_DQ_OUT() = 0; 								
  Delay_ms(20);    								
  DHT11_DQ_OUT() = 1; 								
  Delay_us(30);     								
}
/*****************************************************************************
 : DHT11_Check
 : DHT11У
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static uint8_t DHT11_Check(void) 	   
{   
  uint8_t retry = 0;
  
  DHT11_IO_IN();
  while (DHT11_DQ_IN() && (retry < 100))				
  {
    retry++;
    Delay_us(1);
  }	 
  
  if(retry >= 100)
    return 1;
  else 
    retry = 0;
  
  while(!DHT11_DQ_IN() && (retry < 100))				        
  {
    retry ++;
    Delay_us(1);
  }
  
  if(retry >= 100)
    return 1;									    
  
  return 0;
}
/*****************************************************************************
 : DHT11_Read_Bit
 : DHT11ȡ1bit
 : 
ز : ȡbit
ʹ˵ : 
*****************************************************************************/
static uint8_t DHT11_Read_Bit(void) 			 
{
  uint8_t retry = 0;
  
  while(DHT11_DQ_IN() && (retry < 100))					//wait become Low level
  {
    retry++;
    Delay_us(1);
  }
  
  retry = 0;
  while(!DHT11_DQ_IN() && (retry < 100))				//wait become High level
  {
    retry++;
    Delay_us(1);
  }
  
  Delay_us(40);//wait 40us
  
  if(DHT11_DQ_IN())
    return 1;
  else 
    return 0;		   
}
/*****************************************************************************
 : DHT11_Read_Byte
 : DHT11ȡֽ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
static uint8_t DHT11_Read_Byte(void)    
{        
  uint8_t i,dat;
  dat = 0;
  
  for(i = 0; i < 8; i ++) 
  {
    dat <<= 1; 
    dat |= DHT11_Read_Bit();
  }						    
  
  return dat;
}
/*****************************************************************************
 : DHT11_Read_Data
 : ȡDHT11
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
uint8_t DHT11_Read_Data(uint8_t *temperature,uint8_t *humidity)
{        
  uint8_t buf[5];
  uint8_t i;
  
  DHT11_Rst();
  if(DHT11_Check() == 0)
  {
    for(i = 0;i < 5;i ++)
    {
      buf[i] = DHT11_Read_Byte();
    }
    
    if((buf[0] + buf[1]+ buf[2] + buf[3]) == buf[4])
    {
      if((buf[0] >= 100) || (buf[2] >= 50))
      {
        
      }
      else
      {
        *humidity=buf[0];
        *temperature=buf[2];
      }
    }
  }
  else 
  {
    return 1;
  }
  return 0;	    
}
/*****************************************************************************
 : DHT11_Init
 : DHT11ʼ
 : 
ز : 
ʹ˵ : 
*****************************************************************************/
uint8_t DHT11_Init(void)
{	 
  GPIO_InitTypeDef  GPIO_InitStructure;
  
  RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, (FunctionalState)ENABLE);	 
  
  GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;				 
  GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 		 
  GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
  GPIO_Init(GPIOB, &GPIO_InitStructure);				 
  GPIO_SetBits(GPIOB,GPIO_Pin_1);		 
  
  DHT11_Rst();  
  return DHT11_Check();
}
